package fractal;
import java.util.Iterator;
import java.util.Vector;

import jm.music.data.Note;
import jm.music.data.Part;
import jm.music.data.Phrase;
import jm.music.data.Score;
import jm.music.tools.Mod;


public class ComposicaoFractal {

	private Score composicao;
	private Part parte;
	private Construtor construtor;
	private Vector listaDeNotas;
	private int iteracoes;
	private boolean comprimirIntervalos;


	public ComposicaoFractal(Construtor construtor, int iteracoes, boolean comprimirIntervalos) {
		this.comprimirIntervalos = comprimirIntervalos;
		this.composicao = new Score();
		this.parte = new Part();
		this.parte.add(construtor);
		this.iteracoes = iteracoes;
		this.construtor = construtor;
		this.listaDeNotas = construtor.getNoteList();
		criarComposicao(); 
		this.composicao.add(parte);					
	}


	private void criarComposicao(){
		if(iteracoes == 0)return;
		
		Iterator t = listaDeNotas.iterator();

		Note a;
		double duration = 0.0;
		while(t.hasNext()){
			a = (Note)(t.next());


			transladar(a,duration , iteracoes, listaDeNotas );
			duration += a.getRhythmValue(); 			  

		}

	}


	public Score getComposicao(){
		return composicao;
	}


	private void transladar(Note nota, double startTime, int iteracao, Vector listaDeNotas){

		Note a;

		if(iteracao >= 1){


			Phrase copia = new Phrase();
			copia = construtor.copy();
			copia.setStartTime(startTime);			


			double duracaoNota = nota.getDuration();	

			

			Mod.changeLength(copia, duracaoNota);
			
			if(isComprimir()==true){
				double grau = duracaoNota / (construtor.getEndTime() - construtor.getStartTime());				
				grau = 1.0 - grau;
				Mod.expandIntervals(copia, -grau);									
			}
			
			int trans = nota.getPitch() - copia.getLowestPitch();

			Mod.transpose(copia, trans);

			parte.add(copia);

			Iterator t = copia.getNoteList().iterator();

			double duration = startTime;
			while(t.hasNext()){
				a = (Note)(t.next());


				transladar(a,duration , iteracao - 1, copia.getNoteList() );
				duration += a.getRhythmValue(); 
				

			}


			return;
		}



	}


	public boolean isComprimir() {
		return comprimirIntervalos;
	}


	public void setComprimir(boolean expandir) {
		this.comprimirIntervalos = expandir;
	}





}
