package fractal;

import jm.music.tools.Mod;
import jm.util.View;

public class Principal {

	private static Principal instance;
	private Construtor construtor;
	private ComposicaoFractal composicaoFractal;


	private Principal() {}

	public static Principal getInstance(){
		if(instance == null) instance = new Principal();
		return instance;
	}

	public void criarNovaComposicao(){
		construtor = new Construtor();
	}

	public boolean adicionarNota(int pitch, double valorRitmico, double duracao){
		if(construtor != null){
			construtor.adicionarNota(pitch, valorRitmico, duracao);
			return true;
		}
		return false;
	}

	public boolean gerarComposicaoFractal(int iteracoes, boolean expandir){
		if(construtor != null){			
			composicaoFractal = new ComposicaoFractal(construtor, iteracoes, expandir);
			return true;
		}
		return false;
	}

	public boolean mostrarComposicao(){
		if(composicaoFractal != null){
			View.show(composicaoFractal.getComposicao());
			return true;
		}
		return false;
	}

	public boolean mostraConstrutor(){
		if(construtor != null){
			View.show(construtor);
			return true;
		}
		return false;
	}

	public boolean repetirConstrutor() {
		if(construtor != null){
			Mod.repeat(construtor);
			return true;
		}
		return false;

	}

	public boolean comprimirIntervalos(boolean value) {		
		if(composicaoFractal != null){
			composicaoFractal.setComprimir(value);
			return true;
		}
		return false;

	}
	
	public ComposicaoFractal getComposicaoFractal() {
		return composicaoFractal;
	}
}
