package gui;


import fractal.Principal;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;

public class Janela extends JFrame implements ActionListener {

	private static final long serialVersionUID = 1L;
	private JButton criarNova;
	private JButton adicionarNota;
	private JButton mostrarConstrutor;
	private JButton gerarComposicaoFractal;
	private JButton mostrarComposicaoFractal;
	private JButton repetirConstrutor;
	private JSpinner notaMIDI;
	private JSpinner duracao;
	private JSpinner valorRitmico;
	private JSpinner numeroIteracoes;
	private JLabel labelMIDI;
	private JLabel labelDuracao;
	private JLabel labelValorRitmico;
	private JLabel labelNumeroIteracoes;
	private JPanel painel;
	private JPanel painel2;
	private JPanel painel3;
	private JPanel painel4;
	private JPanel painel5;
	private JPanel painel6;
	private JPanel painel7;
	private JPanel painel8;
	private JPanel painelConsole;
	private JTextArea console;
	private JCheckBox comprimirIntervalosBox;

	public Janela(String nome) {	
		super(nome);
		initComponents();

		
		painel = new JPanel(new BorderLayout());
		painel2 = new JPanel();
		painel3 = new JPanel();
		painel4 = new JPanel();
		painel5 = new JPanel();
		painel6 = new JPanel();
		painel7 = new JPanel();
		painel8 = new JPanel();
		painelConsole = new JPanel();
		
		painel3.setLayout(new BoxLayout(painel3, BoxLayout.PAGE_AXIS));
		painel4.setLayout(new BoxLayout(painel4, BoxLayout.PAGE_AXIS));
		
		//painel.setBackground(Color.WHITE);
		painel2.setBackground(Color.BLACK);
		painel3.setBackground(Color.WHITE);
		painel4.setBackground(Color.WHITE);
		painel5.setBackground(Color.WHITE);
		painel6.setBackground(Color.WHITE);
		painel7.setBackground(Color.WHITE);
		painel8.setBackground(Color.WHITE);
		
		Dimension d = new Dimension();
		d.width = 600;
		d.height = 50;			
		painel5.setMaximumSize(d);
		painel6.setMaximumSize(d);
		painel7.setMaximumSize(d);
		painel8.setMaximumSize(d);
		
		painel2.add(criarNova);		
		
				
		
		
		painel5.add(labelMIDI);		
		painel5.add(notaMIDI);
		
		painel6.add(labelDuracao);		
		painel6.add(duracao);
		
		painel7.add(labelValorRitmico);
		painel7.add(valorRitmico);
		
		painel8.add(labelNumeroIteracoes);
		painel8.add(numeroIteracoes);
		
		painel3.add(painel5);
		painel3.add(painel6);
		painel3.add(painel7);
		
		adicionarNota.setAlignmentX(Component.CENTER_ALIGNMENT);
		mostrarConstrutor.setAlignmentX(Component.CENTER_ALIGNMENT);
		repetirConstrutor.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		painel3.add(adicionarNota);			
		painel3.add(mostrarConstrutor);
		painel3.add(repetirConstrutor);
		
		gerarComposicaoFractal.setAlignmentX(Component.CENTER_ALIGNMENT);
		mostrarComposicaoFractal.setAlignmentX(Component.CENTER_ALIGNMENT);
		comprimirIntervalosBox.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		painel4.add(painel8);
		painel4.add(gerarComposicaoFractal);
		painel4.add(mostrarComposicaoFractal);
		painel4.add(comprimirIntervalosBox);

		
		painel3.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		painel4.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		
		
		painel.add(painel2, BorderLayout.PAGE_START);
		painel.add(painel3, BorderLayout.LINE_START);
		painel.add(painel4, BorderLayout.LINE_END);
	
		
		JScrollPane areaScrollPane = new JScrollPane(console);
		areaScrollPane.setVerticalScrollBarPolicy(
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		//areaScrollPane.setPreferredSize(new Dimension(250, 250));

		painelConsole.add(areaScrollPane);
		

		
		
		painel.add(painelConsole, BorderLayout.PAGE_END);
		
		getContentPane().add(painel);


		pack();
		setSize(800, 600);
		setVisible(true);
	}

	private void initComponents(){
		
		
		
		ImageIcon criarNovaIcon = createImageIcon("imagens/criarNova.jpg");
		ImageIcon adicionarNotaIcon = createImageIcon("imagens/criarNova.jpg");
		ImageIcon mostrarConstrutorIcon = createImageIcon("imagens/criarNova.jpg");
		ImageIcon gerarComposicaoFractalIcon = createImageIcon("imagens/criarNova.jpg");
		ImageIcon mostrarComposicaoFractalIcon = createImageIcon("imagens/criarNova.jpg");
		ImageIcon repetirConstrutorIcon = createImageIcon("imagens/criarNova.jpg");
		
		criarNova = new JButton("Criar Nova Composio", criarNovaIcon);
		criarNova.setActionCommand("criar");
		criarNova.addActionListener(this);
		adicionarNota = new JButton("Adicionar Nota", adicionarNotaIcon);
		adicionarNota.setActionCommand("adicionar");
		adicionarNota.addActionListener(this);
		mostrarConstrutor = new JButton("Visualizar o Construtor", mostrarConstrutorIcon);
		mostrarConstrutor.setActionCommand("mostrar");
		mostrarConstrutor.addActionListener(this);		
		gerarComposicaoFractal = new JButton("Gerar Composicao Fractal", gerarComposicaoFractalIcon);
		gerarComposicaoFractal.setActionCommand("gerar");
		gerarComposicaoFractal.addActionListener(this);
		mostrarComposicaoFractal = new JButton("Mostrar Composicao Fractal", mostrarComposicaoFractalIcon);
		mostrarComposicaoFractal.setActionCommand("mostrarFractal");
		mostrarComposicaoFractal.addActionListener(this);
		repetirConstrutor = new JButton("Repetir", repetirConstrutorIcon);
		repetirConstrutor.setActionCommand("repetir");
		repetirConstrutor.addActionListener(this);
		
		
		labelMIDI = new JLabel("Pitch (MIDI)");		
		SpinnerModel model = new SpinnerNumberModel(0,0,127,1);
		notaMIDI = new JSpinner(model);
		labelMIDI.setLabelFor(notaMIDI);
		
		labelDuracao = new JLabel("Durao da Nota (segundos)");		
		SpinnerModel model2 = new SpinnerNumberModel(0.0,0.0,60.0,0.1);
		duracao = new JSpinner(model2);
		labelDuracao.setLabelFor(duracao);
		
		labelValorRitmico = new JLabel("Valor Ritmico (segundos)");		
		SpinnerModel model3 = new SpinnerNumberModel(0.0,0.0,60.0,0.1);
		valorRitmico = new JSpinner(model3);
		labelValorRitmico.setLabelFor(valorRitmico);
		
		labelNumeroIteracoes = new JLabel("Nmero de Iteraes");		
		SpinnerModel model4 = new SpinnerNumberModel(0,0,10,1);
		numeroIteracoes = new JSpinner(model4);
		labelNumeroIteracoes.setLabelFor(numeroIteracoes);
		
		console =  new JTextArea(5,50);
		
		comprimirIntervalosBox =  new JCheckBox("Comprimir intervalo entre as notas");
		comprimirIntervalosBox.setSelected(false);		
	}

	public static void main(String[] args) {		

		Janela janela = new Janela("Composio Fractal");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	}


	protected static ImageIcon createImageIcon(String path) {	    

		return new ImageIcon(path);
	}

	public void actionPerformed(ActionEvent e) {
		boolean resposta;
		if ("criar".equals(e.getActionCommand())) {
			Principal.getInstance().criarNovaComposicao();
			mostrarMensagem("Nova composio criada!");
			return;
		} 
		if ("adicionar".equals(e.getActionCommand())) {
			
			Integer pitch = (Integer) notaMIDI.getValue();
			Double valor = (Double) valorRitmico.getValue();
			Double dura = (Double) duracao.getValue();
			
			System.out.println(valor.doubleValue());
			
			resposta = Principal.getInstance().adicionarNota(pitch.intValue(),  valor.doubleValue() , dura.doubleValue() );
			if(resposta == true) mostrarMensagem("Nota adicionada ---> Pitch: "+ pitch + ", Valor Rtmico: " + valor +  ", Durao: " + dura );
			else mostrarMensagem(" preciso criar uma nova composio antes de poder adicionar as notas!\nClique em \"Criar Nova Composio\"");
			return;
		} 
		
		if ("mostrar".equals(e.getActionCommand())) {
			resposta = Principal.getInstance().mostraConstrutor();
			if(resposta == true) mostrarMensagem("Construtor da Nota sendo exibido..." );
			else mostrarMensagem(" preciso criar uma nova composio antes de poder exibir o construtor!\nClique em \"Criar Nova Composio\"");
		
			return;
		}
		
		if ("gerar".equals(e.getActionCommand())) {
			Integer iteracoes = (Integer) numeroIteracoes.getValue();
			System.out.println(comprimirIntervalosBox.isSelected());
			resposta = Principal.getInstance().gerarComposicaoFractal(iteracoes.intValue(), comprimirIntervalosBox.isSelected());
			if(resposta == true) mostrarMensagem("Gerando composio fractal..." );
			else mostrarMensagem(" preciso criar uma nova composio antes de poder gerar um fractal!\nClique em \"Criar Nova Composio\"");
		
			return;
		}
		
		if ("mostrarFractal".equals(e.getActionCommand())) {
			resposta = Principal.getInstance().mostrarComposicao();
			if(resposta == true) mostrarMensagem("Exibindo composio fractal..." );
			else mostrarMensagem(" preciso criar uma nova composio antes de poder exibir um fractal!\nClique em \"Criar Nova Composio\"");
		
			return;
		}
		
		if ("repetir".equals(e.getActionCommand())) {
			resposta = Principal.getInstance().repetirConstrutor();
			if(resposta == true) mostrarMensagem("Repetindo o construtor..." );
			else mostrarMensagem(" preciso criar uma nova composio antes de poder repetir o construtor!\nClique em \"Criar Nova Composio\"");
		
			return;
		}
		
		
		
	}
	
	

	
	private void mostrarMensagem(String mensagem){
		console.append("" + mensagem + "\n");
	}




}
